﻿using System;
using System.IO;
using System.Drawing;
using System.Windows.Forms;

class ChangeSeats
{
	[STAThread()]
	private static void Main()
	{
		Application.EnableVisualStyles();
		Application.DoEvents();
		Application.Run(new MainForm());
	}
}

class MainForm: Form
{
	public int i, j, cnt = 0;
	public string[] Seat = new string[40];
	Random rand = new Random();
	Rectangle[] rects = new Rectangle[40];

	Form SubForm = new Form();
	Label Label01 = new Label();
	Label[] LabelSeat = new Label[40];
	Button RunBtn;
	Button FileOpenBtn = new Button();
	Button ShuffleBtn = new Button();
	Button OkBtn = new Button();
	TextBox[] student = new TextBox[40];
	MenuItem miRun, miSeparator1, miExit, miHelp, miSeparator2, miVersion;
	MenuItem miFile, miAbout;
	ProgressBar mfProg = new ProgressBar();
	ProgressBar sfProg = new ProgressBar();
	StatusStrip sStrip = new StatusStrip();
	ToolStripStatusLabel[] tsSLabel = new ToolStripStatusLabel[5];
	ToolStripSeparator tsSeparator = new ToolStripSeparator();

	public MainForm()
	{

		Text = "席替えツール　E1版";
		Width = 1024;
		Height = 600;
		MaximizeBox = false;
		MinimizeBox = false;
		//TopMost = true;
		FormBorderStyle = FormBorderStyle.FixedSingle;

		miRun = new MenuItem("学生データを編集する(&E)", new EventHandler(miSetStudents));
		miSeparator1 = new MenuItem("-");
		miExit = new MenuItem("終了する(&R)", new EventHandler(miExitClick));
		miFile = new MenuItem("ファイル(&F)", new MenuItem[] { miRun, miSeparator1, miExit });

		miHelp = new MenuItem("使用方法(&V)", new EventHandler(miHelpClick));
		miSeparator2 = new MenuItem("-");
		miVersion = new MenuItem("バージョン情報(&A)", new EventHandler(miVersionClick));
		miAbout = new MenuItem("ヘルプ(&H)", new MenuItem[] { miHelp, miSeparator2, miVersion });

		Menu = new MainMenu(new MenuItem[]{miFile, miAbout});

		RunBtn = new Button();
		RunBtn.Parent = this;
		RunBtn.Size = new Size(ClientSize.Width / 6, 30);
		RunBtn.Location = new Point(20, 10);
		RunBtn.Text = "席替えする";
		RunBtn.TextAlign = ContentAlignment.MiddleCenter;
		RunBtn.Click += new EventHandler(RunBtn_Click);

		mfProg.Parent = this;
		mfProg.Size = new Size(ClientSize.Width - RunBtn.Location.X - RunBtn.Size.Width - 30, 30);
		mfProg.Location = new Point(RunBtn.Location.X + RunBtn.Size.Width + 20, 10);
		mfProg.Minimum = 0;
		mfProg.Maximum = 0;

		tsSLabel[0] = new ToolStripStatusLabel();
		tsSLabel[1] = new ToolStripStatusLabel();
		tsSLabel[0].Text = "席替えツール（E1 Edition）";
		tsSLabel[1].Text = "Version:1.0α";

		sStrip.Parent = this;
		sStrip.Items.Add(tsSLabel[0]);
		sStrip.Items.Add(tsSLabel[1]);
		sStrip.Items.Add(tsSeparator);

		//sStrip.Text = "Version:1.0α";

		Label01.Parent = this;
		Label01.Size = new Size(ClientSize.Width - 20, 30);
		Label01.Location = new Point(ClientSize.Width / 2 - Label01.Size.Width / 2,
			RunBtn.Location.Y + RunBtn.Size.Height + 5);
		Label01.Text = "←窓　　　　　　　　　　　　　　　　　　　［教卓］ 　　　　　　　　　　　　　　　　　　廊下→";
		Label01.Font = new Font("メイリオ", 14, FontStyle.Bold);
		Label01.TextAlign = ContentAlignment.MiddleCenter;

		cnt = 0;
		for (i = 0; i < 6; i++)
		{
			for (j = (i == 0) ? 1 : 0; j < ((i == 0) ? 6 : 7); j++)
			{
				LabelSeat[cnt] = new Label();
				LabelSeat[cnt].Parent = this;
				LabelSeat[cnt].Size = new Size(96, 48);
				LabelSeat[cnt].Location = new Point(20 + j * (LabelSeat[i].Width + (ClientSize.Width - LabelSeat[i].Width * 7) / 7),
					80 + i * (LabelSeat[i].Height + (ClientSize.Height - sStrip.Height - LabelSeat[i].Height * 7) / 7));
				LabelSeat[cnt].BorderStyle = BorderStyle.FixedSingle;
				LabelSeat[cnt].TextAlign = ContentAlignment.MiddleCenter;
				LabelSeat[cnt].Font = new Font("メイリオ", 14);
				cnt++;
			}
		}

		SubForm.Text = "名簿";
		SubForm.Width = 480;
		SubForm.Height = 450;
		SubForm.FormBorderStyle = FormBorderStyle.FixedToolWindow;

		FileOpenBtn.Parent = SubForm;
		FileOpenBtn.Size = new Size(SubForm.ClientSize.Width / 3 * 2 - 10, 30);
		FileOpenBtn.Location = new Point(10, 10);
		FileOpenBtn.Text = "名簿ファイルを読み込む";
		FileOpenBtn.TextAlign = ContentAlignment.MiddleCenter;
		FileOpenBtn.Click += new EventHandler(FileOpenBtn_Click);

		ShuffleBtn.Parent = SubForm;
		ShuffleBtn.Size = new Size(SubForm.ClientSize.Width / 3 - 10, 30);
		ShuffleBtn.Location = new Point(SubForm.ClientSize.Width - ShuffleBtn.Size.Width, 10);
		ShuffleBtn.Text = "シャッフルする";
		ShuffleBtn.TextAlign = ContentAlignment.MiddleCenter;
		ShuffleBtn.Click += new EventHandler(ShuffleBtn_Click);

		sfProg.Parent = SubForm;
		sfProg.Size = new Size(SubForm.ClientSize.Width - 10, 30);
		sfProg.Location = new Point(SubForm.ClientSize.Width / 2 - sfProg.Size.Width / 2 + 5,
			FileOpenBtn.Location.Y + FileOpenBtn.Size.Height + 10);
		sfProg.Minimum = 0;
		sfProg.Maximum = 0;

		OkBtn.Parent = SubForm;
		OkBtn.Size = new Size(SubForm.ClientSize.Width - 10, 30);
		OkBtn.Location = new Point(SubForm.ClientSize.Width / 2 - OkBtn.Size.Width / 2 + 5,
			SubForm.ClientSize.Height - OkBtn.Size.Height - 2);
		OkBtn.Text = "設定する";
		OkBtn.TextAlign = ContentAlignment.MiddleCenter;
		OkBtn.Click += new EventHandler(OkBtn_Click);

		cnt = 0;
		for (int i = 0; i < 4; i++)
		{
			for (int j = 0; j < 10; j++)
			{
				student[cnt] = new TextBox();
				student[cnt].Parent = SubForm;
				student[cnt].Size = new Size(SubForm.ClientSize.Width / 4 - 10, 30);
				student[cnt].Location = new Point(10 + (student[cnt].Size.Width + 10) * i,
					sfProg.Location.Y + sfProg.Size.Height + 10 + (student[cnt].Size.Height + 10) * j);
				student[cnt].Text = Convert.ToString(cnt + 1);
				cnt++;
			}
		}
	}

	void FileOpenBtn_Click(object sender, EventArgs e)
	{
		OpenFileDialog ofd = new OpenFileDialog();

		ofd.FileName = "default.txt";
		ofd.InitialDirectory = @"C:\Users\Junichi\AppData\Roaming\ChangeSeats";
		ofd.Filter = "名簿ファイル(*.txt)|*.txt|すべてのファイル|*.*";
		ofd.FilterIndex = 1;
		ofd.Title = "名簿ファイルを選択してください";
		ofd.RestoreDirectory = true;

		if (ofd.ShowDialog() == DialogResult.OK)
		{
			Stream stream = ofd.OpenFile();

			if (stream != null)
			{
				StreamReader sReader = new StreamReader(stream, System.Text.Encoding.GetEncoding("shift_jis"));

				//名簿には40行あるものとする
				for (int i = 0; i < 40; i++)
				{
					Seat[i] = sReader.ReadLine();
					student[i].Text = Seat[i];
				}
			}
		}
	}

	void ShuffleBtn_Click(object sender, EventArgs e)
	{
		long progMax = DateTime.Now.Ticks / 1000000000000;
		string[] str = new string[40];
		sfProg.Maximum = (int)progMax;
		sfProg.Value = 0;
		for (i = 0; i < 40; i++)
			str[i] = student[i].Text;
		for (i = 0; i < progMax; i++)
		{
			Swap(ref str[rand.Next(40)], ref str[rand.Next(40)]);
			if (i % 50000 == 0)
				try { sfProg.Value += 50000; }
				catch { sfProg.Value = sfProg.Maximum; }
		}
		for (i = 0; i < 40; i++)
			student[i].Text = str[i];
	}

	void OkBtn_Click(object sender, EventArgs e)
	{
		SubForm.Close();
	}

	void Swap(ref string a, ref string  b)
	{
		string t = a;
		a = b;
		b = t;
	}

	void RunBtn_Click(object sender, EventArgs e)
	{
		long progMax = DateTime.Now.Ticks / 1000000000000;
		mfProg.Maximum = (int)progMax;
		mfProg.Value = 0;
		for (i = 0; i < 40; i++)
			Seat[i] = student[i].Text;
		for (i = 0; i < progMax; i++)
		{
			Swap(ref Seat[rand.Next(40)], ref Seat[rand.Next(40)]);
			if (i % 50000 == 0)
				try { mfProg.Value += 50000; }
				catch { mfProg.Value = mfProg.Maximum; }
		}
		for (i = 0; i < 40; i++)
			LabelSeat[i].Text = Seat[i];
	}

	void miSetStudents(object sender, EventArgs e)
	{
		SubForm.ShowDialog(this);
	}
	
	void miExitClick(object sender, EventArgs e)
	{
		SubForm.Dispose();
		Close();
	}

	void miHelpClick(object sender, EventArgs e)
	{
		MessageBox.Show("（出席番号で表示するなら2.から）\n\n" + 
			"1.[ファイル(&F)]→[学生データを編集する(&E)]を選んで名前を入力\n" +
			"　or [名簿ファイルを読み込む]をクリックしてファイルを読み込む\n" +
			"　（1度シャッフルするなら[シャッフルする]をクリック）\n" +
			"　入力し終わったら[設定する]をクリック\n" +
			"2.[席替えする]をクリック\n" +
			"3.枠の中に名前or出席番号が表示される\n" +
			"　終わり。",
			"このツールの使い方",
			MessageBoxButtons.OK,
			MessageBoxIcon.Information);
	}

	void miVersionClick(object sender, EventArgs e)
	{
		MessageBox.Show("席替えツール（E1 Edition）\tVersion 1.0α\n" +
			"作成者\t@nahcnuj (twitter ID)\n" +
			"作成環境\tMicrosoft Visual C# 2010 Express",
			"このツールについて",
			MessageBoxButtons.OK,
			MessageBoxIcon.Information);
	}

	protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
	{
		// Ctrl + A をボタンのショートカットキーとして処理する
		switch ((int)keyData)
		{
			case (int)Keys.F5:
				this.RunBtn.PerformClick();
				return true;
			case (int)Keys.F1:
				this.miHelp.PerformClick();
				return true;
		}

		return base.ProcessCmdKey(ref msg, keyData);
	}

	protected override void OnPaint(PaintEventArgs e)
	{
		Graphics g = e.Graphics;

		base.OnPaint(e);

		//g.DrawRectangles(new Pen(Color.Black, 3));
	}
}